import numpy as np
import getpass
import argparse
import warnings
import pickle
warnings.filterwarnings('ignore')
user = getpass.getuser()

# SOME STATISTICS #
def pc_bias(s,o):
        return 100.0*sum(s-o)/sum(o)
def bias(s,o):
        return np.mean(s-o)
def correlation(s,o):
        return np.corrcoef(o, s)[0,1]
def rmse(s,o):
        return np.sqrt(np.mean((s-o)**2))
def nstd(s,o):
        return np.std(s)/np.std(o)



date1='1998'
date2='2011'
workdir='/cluster/work/users/'
experiment = '020'
region='NA2'

if region == "TP0":
        print("masks for TP0 does not exist, terminating the script")
        quit()
        region = "TP0a1.00"
if region == "TP2":
        print("masks for TP2 does not exist, terminating the script")
        quit()
        region = "TP2a0.10"
if region == "TP4":
        print("masks for TP4 does not exist, terminating the script")
        quit()
        region = "TP4a0.12"
if region == "TP5":
        f=open('maskTP5.pckl','rb')
        REGmask = pickle.load(f)
        f.close()
        region = "TP5a0.06"
if region == "NAT":
        f=open('maskNA2.pckl','rb')
        REGmask = pickle.load(f)
        f.close()
        region = "NATa1.00"
if region == "NA2":
        f=open('maskNA2.pckl','rb')
        REGmask = pickle.load(f)
        f.close()
        region = "NA2a0.80"

experiment = 'expt_'+experiment[0:2]+'.'+experiment[2]

f = open(workdir + user + "/" + \
             region + "/" + experiment + "/data/CHL_subregions_"+\
                    date1+"_"+str(int(date2)-1)+".pckl","rb")
DATA020 = pickle.load(f)
f.close()


experiment = '021'
experiment = 'expt_'+experiment[0:2]+'.'+experiment[2]

f = open(workdir + user + "/" + \
             region + "/" + experiment + "/data/CHL_subregions_"+\
                    date1+"_"+str(int(date2)-1)+".pckl","rb")
DATA021 = pickle.load(f)
f.close()


experiment = '022'
experiment = 'expt_'+experiment[0:2]+'.'+experiment[2]

f = open(workdir + user + "/" + \
             region + "/" + experiment + "/data/CHL_subregions_"+\
                    date1+"_"+str(int(date2)-1)+".pckl","rb")
DATA022 = pickle.load(f)
f.close()


grids=50
bintype='log'
xmax=2
xmin=-2
cmap='binary'
cmax=4
cmin=0

def plot(grids,bintype,xmin,xmax,cmap,cmin,cmax):
 figure=plt.figure(figsize=(10,6))

 subregion='Barents'
 ax=figure.add_subplot(3,4,1)
 hb = plt.hexbin(np.log10(DATA020['MODall'][subregion]),np.log10(DATA020['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA020['MODall'][subregion]),np.log10(DATA020['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA020['MODall'][subregion]),p(np.log10(DATA020['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,2)
 hb = plt.hexbin(np.log10(DATA021['MODall'][subregion]),np.log10(DATA021['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA021['MODall'][subregion]),np.log10(DATA021['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA021['MODall'][subregion]),p(np.log10(DATA021['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,3)
 hb = plt.hexbin(np.log10(DATA022['MODall'][subregion]),np.log10(DATA022['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA022['MODall'][subregion]),np.log10(DATA022['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA022['MODall'][subregion]),p(np.log10(DATA022['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,4)
 hb = plt.hexbin(np.log10(DATA020['SATimr'][subregion]['SATall']),np.log10(DATA020['IMR'][subregion]['IMRall']) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax/4])
 z = np.polyfit(np.log10(DATA020['SATimr'][subregion]['SATall']),np.log10(DATA020['IMR'][subregion]['IMRall']), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA020['SATimr'][subregion]['SATall']),p(np.log10(DATA020['SATimr'][subregion]['SATall'])),"-",color='lightgrey')

 subregion='NorwegianN'
 ax=figure.add_subplot(3,4,5)
 hb = plt.hexbin(np.log10(DATA020['MODall'][subregion]),np.log10(DATA020['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA020['MODall'][subregion]),np.log10(DATA020['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA020['MODall'][subregion]),p(np.log10(DATA020['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,6)
 hb = plt.hexbin(np.log10(DATA021['MODall'][subregion]),np.log10(DATA021['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA021['MODall'][subregion]),np.log10(DATA021['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA021['MODall'][subregion]),p(np.log10(DATA021['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,7)
 hb = plt.hexbin(np.log10(DATA022['MODall'][subregion]),np.log10(DATA022['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA022['MODall'][subregion]),np.log10(DATA022['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA022['MODall'][subregion]),p(np.log10(DATA022['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,8)
 hb = plt.hexbin(np.log10(DATA020['SATimr'][subregion]['SATall']),np.log10(DATA020['IMR'][subregion]['IMRall']) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax/4])
 z = np.polyfit(np.log10(DATA020['SATimr'][subregion]['SATall']),np.log10(DATA020['IMR'][subregion]['IMRall']), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA020['SATimr'][subregion]['SATall']),p(np.log10(DATA020['SATimr'][subregion]['SATall'])),"-",color='lightgrey')


 subregion='NorwegianS'
 ax=figure.add_subplot(3,4,9)
 hb = plt.hexbin(np.log10(DATA020['MODall'][subregion]),np.log10(DATA020['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA020['MODall'][subregion]),np.log10(DATA020['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA020['MODall'][subregion]),p(np.log10(DATA020['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,10)
 hb = plt.hexbin(np.log10(DATA021['MODall'][subregion]),np.log10(DATA021['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA021['MODall'][subregion]),np.log10(DATA021['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA021['MODall'][subregion]),p(np.log10(DATA021['MODall'][subregion])),"-",color='lightgrey')


 ax=figure.add_subplot(3,4,11)
 hb = plt.hexbin(np.log10(DATA022['MODall'][subregion]),np.log10(DATA022['SATall'][subregion]) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax])
 z = np.polyfit(np.log10(DATA022['MODall'][subregion]),np.log10(DATA022['SATall'][subregion]), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA022['MODall'][subregion]),p(np.log10(DATA022['MODall'][subregion])),"-",color='lightgrey')

 ax=figure.add_subplot(3,4,12)
 hb = plt.hexbin(np.log10(DATA020['SATimr'][subregion]['SATall']),np.log10(DATA020['IMR'][subregion]['IMRall']) , gridsize=grids, bins=bintype, cmap=cmap)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.colorbar(hb, ax=ax)
 plt.xlim([xmin,xmax]); plt.ylim([xmin,xmax]); plt.plot([xmin,xmax],[xmin,xmax],color='gray')
 plt.clim([cmin,cmax/4])
 z = np.polyfit(np.log10(DATA020['SATimr'][subregion]['SATall']),np.log10(DATA020['IMR'][subregion]['IMRall']), 1)
 p = np.poly1d(z)
 plt.plot(np.log10(DATA020['SATimr'][subregion]['SATall']),p(np.log10(DATA020['SATimr'][subregion]['SATall'])),"-",color='lightgrey')

 plt.tight_layout()


# scatter imr vs sat vs model
fig = plt.figure(figsize=(6,5))
ax=fig.add_subplot(1,1,1)
region='NorwegianN'
plt.plot([0,2],[0,2],color='lightgrey')
plt.scatter(DATA020["SATimr"][region]["SATave"],DATA020["IMR"][region]["IMRave"],s=15,color='k',label='satellite')
plt.scatter(DATA020["MODimr"][region]["MODave"],DATA020["IMR"][region]["IMRave"],s=15,color='b',label='EXP2')
plt.scatter(DATA021["MODimr"][region]["MODave"],DATA020["IMR"][region]["IMRave"],s=15,color='r',label='EXP1')
plt.scatter(DATA022["MODimr"][region]["MODave"],DATA020["IMR"][region]["IMRave"],s=15,color='g',label='EXP3')
plt.xlim([0,2]); plt.ylim([0,2])
plt.xlabel('estimated')
plt.ylabel('observed')
plt.tight_layout()


fig2 = plt.figure(figsize=(12,4))
ax=fig2.add_subplot(1,3,1)
region='Barents'
plt.plot([-2,2],[-2,2],color='lightgrey')
plt.scatter(np.log10(DATA020["SATimr"][region]["SATave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='k',label='satellite')
z = np.polyfit(np.log10(DATA020["SATimr"][region]["SATave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
p = np.poly1d(z)
plt.plot(np.log10(DATA020["SATimr"][region]["SATave"]),p(np.log10(DATA020["SATimr"][region]["SATave"])),color='k')
plt.scatter(np.log10(DATA021["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#0f6fb9',label='EXP1')
#z = np.polyfit(np.log10(DATA020["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA020["MODimr"][region]["MODave"]),p(np.log10(DATA020["MODimr"][region]["MODave"])),color='b')
plt.scatter(np.log10(DATA020["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#f05e31',label='EXP2')
#z = np.polyfit(np.log10(DATA021["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA021["MODimr"][region]["MODave"]),p(np.log10(DATA021["MODimr"][region]["MODave"])),color='r')
plt.scatter(np.log10(DATA022["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#0aa775',label='EXP3')
#z = np.polyfit(np.log10(DATA022["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA022["MODimr"][region]["MODave"]),p(np.log10(DATA022["MODimr"][region]["MODave"])),color='g')
plt.xlim([-1,1]); plt.ylim([-1,1])
plt.xlabel(r'estimated (log$_{10}$(mg m$^{-3}$))')
plt.ylabel(r'observed (log$_{10}$(mg m$^{-3}$))')
plt.title('Barents')
plt.legend(loc='upper right',labelspacing=0.05)
ax.text(-0.95, 0.85, 'a)', fontsize=14)
plt.tight_layout()

region='NorwegianN'
ax=fig2.add_subplot(1,3,2)
plt.plot([-2,2],[-2,2],color='lightgrey')
plt.scatter(np.log10(DATA020["SATimr"][region]["SATave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='k',label='satellite')
z = np.polyfit(np.log10(DATA020["SATimr"][region]["SATave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
p = np.poly1d(z)
plt.plot(np.log10(DATA020["SATimr"][region]["SATave"]),p(np.log10(DATA020["SATimr"][region]["SATave"])),color='k')
plt.scatter(np.log10(DATA021["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#66c2a5',label='EXP1')
#z = np.polyfit(np.log10(DATA020["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA020["MODimr"][region]["MODave"]),p(np.log10(DATA020["MODimr"][region]["MODave"])),color='b')
plt.scatter(np.log10(DATA020["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#fc8d62',label='EXP2')
#z = np.polyfit(np.log10(DATA021["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA021["MODimr"][region]["MODave"]),p(np.log10(DATA021["MODimr"][region]["MODave"])),color='r')
plt.scatter(np.log10(DATA022["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#8da0cb',label='EXP3')
#z = np.polyfit(np.log10(DATA022["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA022["MODimr"][region]["MODave"]),p(np.log10(DATA022["MODimr"][region]["MODave"])),color='g')
plt.xlim([-1,1]); plt.ylim([-1,1])
plt.xlabel(r'estimated (log$_{10}$(mg m$^{-3}$))')
plt.ylabel(r'observed (log$_{10}$(mg m$^{-3}$))')
plt.title('NorwegianN')
ax.text(-0.95, 0.85, 'b)', fontsize=14)
plt.tight_layout()

region='NorwegianS'
ax=fig2.add_subplot(1,3,3)
plt.plot([-2,2],[-2,2],color='lightgrey')
plt.scatter(np.log10(DATA020["SATimr"][region]["SATave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='k',label='satellite')
z = np.polyfit(np.log10(DATA020["SATimr"][region]["SATave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
p = np.poly1d(z)
plt.plot(np.log10(DATA020["SATimr"][region]["SATave"]),p(np.log10(DATA020["SATimr"][region]["SATave"])),color='k')
plt.scatter(np.log10(DATA021["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#66c2a5',label='EXP1')
#z = np.polyfit(np.log10(DATA020["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA020["MODimr"][region]["MODave"]),p(np.log10(DATA020["MODimr"][region]["MODave"])),color='b')
plt.scatter(np.log10(DATA020["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#fc8d62',label='EXP2')
#z = np.polyfit(np.log10(DATA021["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA021["MODimr"][region]["MODave"]),p(np.log10(DATA021["MODimr"][region]["MODave"])),color='r')
plt.scatter(np.log10(DATA022["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='#8da0cb',label='EXP3')
#z = np.polyfit(np.log10(DATA022["MODimr"][region]["MODave"]),np.log10(DATA020["IMR"][region]["IMRave"]),1)
#p = np.poly1d(z)
#plt.plot(np.log10(DATA022["MODimr"][region]["MODave"]),p(np.log10(DATA022["MODimr"][region]["MODave"])),color='g')
plt.xlim([-1,1]); plt.ylim([-1,1])
plt.xlabel(r'estimated (log$_{10}$(mg m$^{-3}$))')
plt.ylabel(r'observed (log$_{10}$(mg m$^{-3}$))')
plt.title('NorwegianS')
ax.text(-0.95, 0.85, 'c)', fontsize=14)
plt.tight_layout()

fig2.canvas.print_figure("../POSTPROCESS/ECOSMO_PAPER_SCRIPTS_Ekim2020/chl_vs_imr.png",dpi=180)


fig2 = plt.figure(figsize=(8,4))
ax=fig2.add_subplot(3,1,1)
region='Barents'
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='k',label='in situ')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA020["SATimr"][region]["SATave"]),s=15,color='#ca0020',label='satellite')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA021["MODimr"][region]["MODave"]),s=15,color='#f4a582',label='EXP1')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA020["MODimr"][region]["MODave"]),s=15,color='#92c5de',label='EXP2')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA022["MODimr"][region]["MODave"]),s=15,color='#0571b0',label='EXP3')
plt.xlim([1998,2011])
plt.ylim([-1,1])
plt.tight_layout()

ax=fig2.add_subplot(3,1,2)
region='NorwegianN'
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA020["IMR"][region]["IMRave"]),s=15,color='k',label='in situ')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA020["SATimr"][region]["SATave"]),s=15,color='#ca0020',label='satellite')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA021["MODimr"][region]["MODave"]),s=15,color='#f4a582',label='EXP1')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA020["MODimr"][region]["MODave"]),s=15,color='#92c5de',label='EXP2')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            np.log10(DATA022["MODimr"][region]["MODave"]),s=15,color='#0571b0',label='EXP3')
plt.xlim([1998,2011])
plt.ylim([-1,1])
plt.tight_layout()

ax=fig2.add_subplot(3,1,3)
region='NorwegianS'
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            DATA020["IMR"][region]["IMRave"],s=15,color='k',label='in situ')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            DATA020["SATimr"][region]["SATave"],s=15,color='#ca0020',label='satellite')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            DATA021["MODimr"][region]["MODave"],s=15,color='#f4a582',label='EXP1')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            DATA020["MODimr"][region]["MODave"],s=15,color='#92c5de',label='EXP2')
plt.scatter(DATA020["MODimr"][region]['YEARave']+DATA020["MODimr"][region]['DAYave']/365.,\
            DATA022["MODimr"][region]["MODave"],s=15,color='#0571b0',label='EXP3')
plt.xlim([1998,2011])
plt.ylim([-1,1])
plt.tight_layout()



# FOR THE PAPER

fig2 = plt.figure(figsize=(12,4))
sp=0
figlabel = ['a)','b)','c)']
for region in ['Barents','NorwegianN','NorwegianS']:
    sp = sp + 1
    ax=fig2.add_subplot(1,3,sp)


    plt.plot([-2,2],[-2,2],color='lightgrey')
    plt.scatter(np.log10(DATA020["SATimr"][region]["SATall"]),np.log10(DATA020["IMR"][region]["IMRall"]),s=15,color='#eadf4a',label='_nolegend_',alpha=0.5,EdgeColor=None)
#    z = np.polyfit(np.log10(DATA020["SATimr"][region]["SATall"]),np.log10(DATA020["IMR"][region]["IMRall"]),1)
#    p = np.poly1d(z)
#    plt.plot(np.log10(DATA020["SATimr"][region]["SATall"]),p(np.log10(DATA020["SATimr"][region]["SATall"])),color='k')
    plt.scatter(np.log10(DATA020["SATimr"][region]["SATall"].mean()),np.log10(DATA020["IMR"][region]["IMRall"].mean()),s=150,color='#eadf4a',label='satellite',EdgeColor='k')

    plt.scatter(np.log10(DATA021["MODimr"][region]["MODall"]),np.log10(DATA021["IMR"][region]["IMRall"]),s=15,color='#0f6fb9',label='_nolegend_',alpha=0.5,EdgeColor=None)
#    z = np.polyfit(np.log10(DATA021["MODimr"][region]["MODall"]),np.log10(DATA021["IMR"][region]["IMRall"]),1)
#    p = np.poly1d(z)
#    plt.plot(np.log10(DATA021["MODimr"][region]["MODall"]),p(np.log10(DATA021["MODimr"][region]["MODall"])),color='#0f6fb9')
    plt.scatter(np.log10(DATA021["MODimr"][region]["MODall"].mean()),np.log10(DATA021["IMR"][region]["IMRall"].mean()),s=150,color='#0f6fb9',label='EXP1',EdgeColor='k')

    plt.scatter(np.log10(DATA020["MODimr"][region]["MODall"]),np.log10(DATA020["IMR"][region]["IMRall"]),s=15,color='#f05e31',label='_nolegend_',alpha=0.5,EdgeColor=None)
#    z = np.polyfit(np.log10(DATA020["MODimr"][region]["MODall"]),np.log10(DATA020["IMR"][region]["IMRall"]),1)
#    p = np.poly1d(z)
#    plt.plot(np.log10(DATA020["MODimr"][region]["MODall"]),p(np.log10(DATA020["MODimr"][region]["MODall"])),color='#f05e31')
    plt.scatter(np.log10(DATA020["MODimr"][region]["MODall"].mean()),np.log10(DATA020["IMR"][region]["IMRall"].mean()),s=150,color='#f05e31',label='EXP2',EdgeColor='k')

    plt.scatter(np.log10(DATA022["MODimr"][region]["MODall"]),np.log10(DATA020["IMR"][region]["IMRall"]),s=15,color='#0aa775',label='_nolegend_',alpha=0.5,EdgeColor=None) 
#    z = np.polyfit(np.log10(DATA022["MODimr"][region]["MODall"]),np.log10(DATA022["IMR"][region]["IMRall"]),1)
#    p = np.poly1d(z)
#    plt.plot(np.log10(DATA022["MODimr"][region]["MODall"]),p(np.log10(DATA022["MODimr"][region]["MODall"])),color='#0aa775')
    plt.scatter(np.log10(DATA022["MODimr"][region]["MODall"].mean()),np.log10(DATA020["IMR"][region]["IMRall"].mean()),s=150,color='#0aa775',label='EXP3',EdgeColor='k')

    plt.scatter(np.log10(DATA022["IMR"][region]["IMRall"].mean()),np.log10(DATA022["IMR"][region]["IMRall"].mean()),s=150,color='#da70ab',label='observed',EdgeColor='k')

    plt.xlim([-1,1]); plt.ylim([-1,1])
    plt.xlabel(r'estimated (log$_{10}$(mg m$^{-3}$))')
    plt.ylabel(r'observed (log$_{10}$(mg m$^{-3}$))')
    plt.title(region)
    if sp == 1: plt.legend(loc='upper right',labelspacing=0.05)  
    ax.text(-0.95, 0.85, figlabel[sp-1], fontsize=14)
    plt.tight_layout()
